/* mu_chv - get a value for a CHOICE_VAL field
 * Return the SCR_CMDCHAR that terminated the input of this field.
 * fld_sync = field in data rec agrees with screen
 */
#include "menu.h"
SCR_CMDCHAR mu_chv(pf)
	FIELD *pf;				/* ptr to current FIELD : fld_sync */
	{
	short nchoice;			/* current choice value: {0:9} */
	CHOICE_VAL *pcv;		/* ptr to this field's CHOICE_VAL */
	SCR_CMDCHAR c;			/* most recent user input char */
	short prevlen;			/* length of previous choice display string */
	short curlen;			/* length of current choice display string */
	short i;
	
	prevlen = 0;
	pcv = pf->pcv;
	if ('0' <= *pcv->pc && *pcv->pc <= '9')
		nchoice = *pcv->pc - '0';
	else
		nchoice = 0;
	FOREVER
		{
		/* scr_curs to start of choice display, display current choice */
		scr_curs(pf->line, pf->col + strlen(pf->desc) + 2);
		scr_print("%s", pcv->choices[nchoice]);		/* pf => fld_sync */

		/* erase any leftover from previous choice */
		curlen = strlen(pcv->choices[nchoice]);
		for (i = 0; i < prevlen - curlen; ++i)
			scr_putc(' ');
		for (i = 0; i < prevlen - curlen; ++i)
			scr_putc('\b');
		prevlen = curlen;

		/* get user input and process it */
		c = scr_getkey();
		if (c != SCR_LEFT && c != SCR_RIGHT)
			return (c);
		else if (c == SCR_RIGHT)
			nchoice = IMOD(nchoice + 1, pcv->nchoices);
		else /* c == SCR_LEFT */
			nchoice = IMOD(nchoice - 1, pcv->nchoices);
		*pcv->pc = '0' + nchoice;					/* pf => !fld_sync */
		}
	}
